<script>
    export /**
     * @type {any}
     */
    let nft_metadata_full;

    let default_metadata_object = {
        name: '<invalid data>',
        id: 'N/A',
        base_uri: '',
        owner: 'null',
        revenue_partner: '',
        revenue_split: '',
        is_sellable: '',
        is_transferable: '',
        lottery_data: '',
        max_supply: '',
        symbol: ''
    };

    export /**
     * @type {any}
     */
    let nft_md_obj = nft_metadata_full.objects
        ? nft_metadata_full.objects[nft_metadata_full.id]
        : default_metadata_object;

    export /**
     * @type {any}
     */
    let names = nft_metadata_full.names ? nft_metadata_full.names : {};

    export function id_or_name(id) {
        return id in names ? names[id] : id;
    }

    export function id_or_name_link(id) {
        return '/u/' + (id in names ? names[id] : id.split('.')[2]);
    }
</script>

<div class="px-7 py-3 w-full text-center">
    <div
        class="p-4 flex w-full flex-col border-2 border-solid border-gray-500 rounded-3xl bg-white"
    >
        <div>
            <p class="break-all">{nft_md_obj.base_uri}</p>
        </div>
        <div class="text-xl">
            <h2>{nft_md_obj.name}</h2>
        </div>
        <div class="border-b-2 border-solid border-gray-600 h-[2px]" />

        <div class="flex w-full justify-between text-lg font-semibold px-4 py-1">
            <div>
                <h2>{nft_md_obj.symbol}</h2>
            </div>
            <div>
                <span>({nft_md_obj.id})</span>
            </div>
        </div>
        <div class="border-b-2 border-solid border-gray-600 h-[2px]" />

        <div class="p-3 flex flex-col">
            <div class="columns-3">
                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Issuer:</p>
                    </div>
                    <div class="px-4">
                        {#if nft_md_obj.owner}
                            <a
                                class="underline decoration-dotted break-all hover:text-sky-500"
                                href={id_or_name_link(nft_md_obj.owner)}
                            >
                                {id_or_name(nft_md_obj.owner)}
                            </a>
                        {:else}
                            <p>Invalid</p>
                        {/if}
                    </div>
                </div>
                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Revenue Partner:</p>
                    </div>
                    <div class="px-4">
                        {#if nft_md_obj.revenue_partner}
                            <a
                                class="underline decoration-dotted hover:text-sky-500"
                                href={id_or_name_link(nft_md_obj.revenue_partner)}
                            >
                                {id_or_name(nft_md_obj.revenue_partner)}
                            </a>
                        {:else}
                            <p>None</p>
                        {/if}
                    </div>
                </div>

                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Revenue Split:</p>
                    </div>
                    <div class="px-4">
                        <p>
                            {nft_md_obj.revenue_split != undefined
                                ? (parseFloat(nft_md_obj.revenue_split) / 100)
                                      .toString()
                                      .concat(' %')
                                : 'N/A'}
                        </p>
                    </div>
                </div>

                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Sellable:</p>
                    </div>
                    <div class="px-4">
                        <p>
                            {#if nft_md_obj.is_sellable}
                                Yes
                            {:else}
                                No
                            {/if}
                        </p>
                    </div>
                </div>

                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Transferrable:</p>
                    </div>
                    <div class="px-4">
                        <p>
                            {#if nft_md_obj.is_transferable}
                                Yes
                            {:else}
                                No
                            {/if}
                        </p>
                    </div>
                </div>

                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Is a Lottery:</p>
                    </div>
                    <div class="px-4">
                        <p>
                            {#if nft_md_obj.lottery_data}
                                Yes
                            {:else}
                                No
                            {/if}
                        </p>
                    </div>
                </div>

                <div class="flex gap-8 text-sm font-semibold">
                    <div>
                        <p>Max Supply:</p>
                    </div>
                    <div class="px-4">
                        <p>{nft_md_obj.max_supply != undefined ? nft_md_obj.max_supply : ''}</p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
